<?php

namespace Drupal\web3_provider\PluginForm;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Plugin\PluginFormBase;

/**
 * A base form class for Web3Provider plugin configuration.
 */
class Web3ProviderConfigFormBase extends PluginFormBase {

  /**
   * Return the plugin instance.
   *
   * @return \Drupal\web3_provider\Web3ProviderPluginInterface
   */
  public function getPlugin() {
    return $this->plugin;
  }

  /**
   * {@inheritDoc}
   */
  public function getFormId() {
    $form_id = [];
    $form_id[] = 'web3_provider';
    if ($plugin_id = $this->getPlugin()->getPluginId() ?? NULL) {
      $form_id[] = 'plugin';
      $form_id[] = $plugin_id;
    }
    $form_id[] = 'config';
    $form_id[] = 'form';

    return implode('_', $form_id);
  }

  /**
   * {@inheritDoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    return $this->plugin->buildConfigurationForm($form, $form_state);
  }

  /**
   * {@inheritDoc}
   */
  public function validateConfigurationForm(array &$form, FormStateInterface $form_state) {
    $this->plugin->validateConfigurationForm($form, $form_state);
  }

  /**
   * {@inheritDoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $this->plugin->submitConfigurationForm($form, $form_state);
  }
}
